
#property copyright "Volturnus"
#property link      "Money"

//---- indicator settings
#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1 Sienna
#property indicator_color2 Teal
#property indicator_color3 Teal 
#property indicator_color4 Teal
#property indicator_color5 Teal
#property indicator_color6 Silver
#property indicator_color7 Silver
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 1
#property indicator_width4 1
#property indicator_width5 1
#property indicator_width6 1
#property indicator_width7 1
#property indicator_style1 STYLE_SOLID
#property indicator_style2 STYLE_DASH
#property indicator_style3 STYLE_DOT
#property indicator_style4 STYLE_DASH
#property indicator_style5 STYLE_DOT
#property indicator_style6 STYLE_DOT
#property indicator_style7 STYLE_DOT

//---- constants
#define ShortName    "DynamicBullBearBand"
#define ATRPeriod    50

//---- indicator parameters
extern int    BandPeriod            = 60;
extern double Band1                 = 4;
extern double Band2                 = 4;
extern double Band3                 = 4;

//---- indicator buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double ExtMapBuffer6[];
double ExtMapBuffer7[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   // Buffers
   IndicatorBuffers(7);
   
   // Drawing settings
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexStyle(4,DRAW_LINE);
   SetIndexStyle(5,DRAW_LINE);
   SetIndexStyle(6,DRAW_LINE);
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
   
   // Name and labels
   IndicatorShortName(ShortName);
   Comment("Copyright Volturnsus");
   
   // Buffers
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexBuffer(4,ExtMapBuffer5);
   SetIndexBuffer(5,ExtMapBuffer6);
   SetIndexBuffer(6,ExtMapBuffer7);
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
     // More vars here too...
     int start = 1;
     int limit;
     int counted_bars = IndicatorCounted();

     // check for possible errors
     if(counted_bars < 0) 
        return(-1);
        
     // Only check these
     limit = Bars - 1 - counted_bars;
     
     // Check the signal foreach bar
     for(int i = limit; i >= start; i--)
     {           
         double ATR = iATR(Symbol(), 0, ATRPeriod, i);
         ExtMapBuffer1[i] = iMA(Symbol(), 0, BandPeriod, 0, MODE_SMA, PRICE_CLOSE, i);   
         ExtMapBuffer2[i]  = ExtMapBuffer1[i] + ATR*Band1;
         ExtMapBuffer3[i]  = ExtMapBuffer1[i] + ATR*Band2;
         ExtMapBuffer4[i]  = ExtMapBuffer1[i] - ATR*Band1;
         ExtMapBuffer5[i]  = ExtMapBuffer1[i] - ATR*Band2;
         ExtMapBuffer6[i]  = ExtMapBuffer1[i] + ATR*Band3;
         ExtMapBuffer7[i]  = ExtMapBuffer1[i] - ATR*Band3;
     }
   return(0);
}